/*
 * Copyright © 2006 Carl Worth
 *
 * This program is free software; you can redistribute it and\/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA."
 */

#ifndef _GRID_H_
#define _GRID_H_

#include "dict.h"

#define GRID_SIZE_MAX 5
/* (  3 chars per cell
 *  x GRID_SIZE_MAX cells per row
 *  + 1 newline per row
 * ) x GRID_SIZE_MAX rows per grid
 *   + 1 terminator character
 */
#define GRID_STRING_MAX (((3 * GRID_SIZE_MAX + 1) * GRID_SIZE_MAX) + 1)

typedef struct _grid {
    int size;
    char letters[GRID_SIZE_MAX][GRID_SIZE_MAX];
    char string[GRID_STRING_MAX];

    /* Private, transient state used by enumerate */
    dict_t *results;
} grid_t;

/* size must be 4 or 5 */
void
grid_init (grid_t *grid, int size);

void
grid_set_letters (grid_t 	*grid,
		  const char	*letters);

char *
grid_string (grid_t *grid);

void
grid_solve (grid_t *grid, dict_t *dict, dict_t *solution);

#endif /* _GRID_H_ */
